<template>
  <header :theme="$vuetify.theme.dark ? 'dark' : 'light'">
    <GlobalEvents
      @keydown.18.225.stop.prevent="openMenu"
      @keydown.left.right.up.down.stop.prevent="navigateMenu"
      @keydown.enter="doMenu"
    />

    <nav>
      <label for="header-drop-menu" toggle>Menu</label>
      <input type="checkbox" id="header-drop-menu" />

      <!-- TODO make dynamically rendered from a TS config (less code repetition + type checking for addPanel arg) -->
      <ul ref="ul">
        <li>
          <!-- a is used on big screens, the checkbox and its label are used on small screens -->
          <label for="header-drop-file" toggle>File</label>
          <a href="#">File</a>
          <input type="checkbox" id="header-drop-file" />
          <ul>
            <li><a href="#">Commit</a></li>
            <li><a href="#">Save to branch</a></li>
          </ul>
        </li>
        <li>
          <label for="drop-panels" toggle>Panels</label>
          <a href="#">Panels</a>
          <input type="checkbox" id="drop-panels" />
          <ul>
            <li
              ref="panelentry"
              v-for="(panel, title) in panels"
              :key="title"
              :title="title"
              @click="addPanel(title)"
            >
              <a href="#"
                ><span>{{ title }}</span
                ><img src="../assets/drag_indicator-24px.svg" alt="drag me"
              /></a>
            </li>
          </ul>
        </li>
        <li>
          <!-- a is used on big screens, the checkbox and its label are used on small screens -->
          <label for="drop-options" toggle>Options</label>
          <a href="#">Options</a>
          <input type="checkbox" id="drop-options" />
          <ul>
            <li>
              <v-switch
                v-model="$vuetify.theme.dark"
                label="Theme Dark"
              ></v-switch>
            </li>
          </ul>
        </li>
      </ul>

      <section workspaces>
        <p>workspace:</p>
        <select @change="workspaceDropdownChange">
          <option>custom</option>
          <optgroup
            v-for="(group, groupname) in workspaces"
            :key="groupname"
            :label="groupname"
          >
            <option
              v-for="(layout, name) in group"
              :key="name"
              :value="name"
              :selected="groupname + '+' + name == lastAppliedWorkspace"
              >{{ name }}</option
            >
          </optgroup>
        </select>
      </section>
    </nav>
  </header>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { panels, panelTitle } from "../panels/";
import { layout } from "../lib/goldenlayout/mainLayout";
import { getPanelTitle } from "../lib/goldenlayout/makePanelConfig";
import { workspaces } from "../lib/goldenlayout/workspaces";
import GlobalEvents from "vue-global-events";

@Component({
  components: {
    GlobalEvents,
  },
})
export default class extends Vue {
  private panels = panels;

  get lastAppliedWorkspace(): string {
    return localStorage["lastAppliedWorkspace"] || "";
  }

  private workspaceDropdownChange(a: InputEvent) {
    const select = a.target as HTMLElement;
    const selected = Array.prototype.slice
      .call(select.querySelectorAll("option"))
      .find(select => select.selected);
    const group = selected.parentElement.label;
    this.resetWorkspace(group, selected.value);
  }

  get workspaces() {
    return workspaces;
  }

  public mountDraggers() {
    (this.$refs.panelentry as HTMLElement[]).forEach(entry => {
      layout.addDragger(entry, entry.title as panelTitle);
    });
  }

  private menuHoverChain: HTMLElement[] = [];
  private openMenu() {
    if (this.menuHoverChain.length) {
      // close menu
      this.menuHoverChain.forEach(el => el.removeAttribute("hover"));
      this.menuHoverChain = [];
    } else {
      // open menu
      const firstMenu = (this.$refs.ul as HTMLElement).querySelector(
        "li"
      ) as HTMLElement;
      const firstLi = firstMenu.querySelector("li") as HTMLElement;
      this.menuHoverChain = [firstMenu, firstLi];
      this.menuHoverChain.forEach(el => el.setAttribute("hover", "hover"));
    }
  }
  private doMenu() {
    if (!this.menuHoverChain.length) {
      return;
    }
    this.menuHoverChain[this.menuHoverChain.length - 1].click();
    this.openMenu();
  }
  private navigateMenu(e: KeyboardEvent) {
    if (!this.menuHoverChain.length) {
      return;
    }
    const rootLis = (this.$refs.ul as Element).children;

    if (e.key == "ArrowRight" || e.key == "ArrowLeft") {
      if (
        this.menuHoverChain.length > 2 &&
        e.key == "ArrowRight" &&
        this.menuHoverChain[this.menuHoverChain.length - 1].querySelector("li")
      ) {
        // press 'right' when selecting an item with a submenu
        const subli = this.menuHoverChain[
          this.menuHoverChain.length - 1
        ].querySelector("li");
        if (subli) {
          subli.setAttribute("hover", "hover");
          this.menuHoverChain.push(subli);
        }
      } else if (this.menuHoverChain.length > 2 && e.key == "ArrowLeft") {
        // press 'left' when in a submenu
        const subli = this.menuHoverChain.pop() as HTMLElement;
        subli.removeAttribute("hover");
      } else {
        // press left or right to switch top-menu
        this.menuHoverChain.forEach(el => el.removeAttribute("hover"));

        let el = this.menuHoverChain[0];
        if (e.key == "ArrowRight") {
          el = (el.nextElementSibling || rootLis[0]) as HTMLElement;
        } else {
          el = (el.previousElementSibling ||
            rootLis[rootLis.length - 1]) as HTMLElement;
        }

        const subel = el.querySelector("li") as HTMLElement;
        el.setAttribute("hover", "hover");
        subel.setAttribute("hover", "hover");
        this.menuHoverChain = [el, subel];
      }
    } else if (e.key == "ArrowUp" || e.key == "ArrowDown") {
      let el = this.menuHoverChain[this.menuHoverChain.length - 1];
      const all = (el.parentElement as HTMLElement).querySelectorAll("li");
      el.removeAttribute("hover");
      if (e.key == "ArrowUp") {
        el = (el.previousElementSibling || all[all.length - 1]) as HTMLElement;
      } else {
        el = (el.nextElementSibling || all[0]) as HTMLElement;
      }
      el.setAttribute("hover", "hover");
      this.menuHoverChain[this.menuHoverChain.length - 1] = el;
    }
  }

  private addPanel(name: string) {
    const title = getPanelTitle(name);
    if (title) {
      layout.addPanel(title);
    }
  }

  private resetWorkspace(group?: string, name?: string) {
    if (!group || !name) {
      delete localStorage["lastAppliedWorkspace"];
      return;
    }
    const workspace = workspaces[group]?.[name];
    if (!workspace) {
      console.error("no workspace with name", name);
      return;
    }
    localStorage["lastAppliedWorkspace"] = group + "+" + name;
    layout.resetLayout(workspace);
  }
}
</script>

<style scoped lang="scss">
@import "../styles/variables/z-index";
@import "../styles/variables/theme_colors";

$dropdown-width: 200px;
$dropdown-hover-background: darken($theme-background-light, 5);

nav {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  font-size: 12px;
}

nav section[workspaces] {
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
  padding: 0 8px;
  p {
    margin: 0;
    margin-right: 3px;
  }
}

[toggle],
input[type="checkbox"] {
  display: none;
}

nav .v-input {
  margin: 0;
  padding: 16px;
  padding-bottom: 0;
}

nav {
  margin: 0;
  padding: 0;
}

nav ul {
  padding: 0;
  margin: 0;
  list-style: none;
  position: relative;
  z-index: $z-control;
}

nav ul li {
  margin: 0;
  display: inline-block;

  [theme="light"] & {
    background-color: $theme-background-light;
    a {
      color: $theme-primary-text-light;
    }
  }
  [theme="dark"] & {
    background-color: $theme-background-dark;
    a {
      color: $theme-primary-text-dark;
    }
  }
}

nav a {
  display: flex;
  flex-direction: row;
  justify-content: space-between;

  // padding: 14px 20px;
  padding: 6px 8px;
  text-decoration: none;

  img {
    height: 17px;
    width: 17px;
    margin: 0;
    padding: 0;
    position: relative;
    // right: -20px + 5px;
  }
}

nav img {
  display: block;
}

nav ul li:hover,
nav ul li[hover],
nav a:hover {
  [theme="light"] & {
    background: darken($theme-background-light, 5);
  }
  [theme="dark"] & {
    background: lighten($theme-background-dark, 5);
  }
}

nav ul li ul {
  // border: 1px solid;
  // border-top: none;
  [theme="light"] & {
    box-shadow: 0px 3px 3px 0px darken($theme-background-light, 10);
  }
  [theme="dark"] & {
    box-shadow: 0px 3px 3px 0px lighten($theme-background-dark, 10);
  }
}

// nav ul li ul li {
//   [theme="light"] & {
//     background: darken($theme-background-light, 3);
//   }
//   [theme="dark"] & {
//     background: lighten($theme-background-dark, 3);
//   }
// }

/* Hide Dropdowns by Default
 * and giving it a position of absolute */
nav ul ul {
  display: none;
  position: absolute;
  /* has to be the same number as the "line-height" of "nav a" */
  // top: 60px;
}

/* Display Dropdowns on Hover */
nav ul li:hover > ul,
nav ul li[hover] > ul {
  display: inherit;
}

/* Fisrt Tier Dropdown */
nav ul ul li {
  width: $dropdown-width;
  display: list-item;
  position: relative;
}

/* Second, Third and more Tiers	
 * We move the 2nd and 3rd etc tier dropdowns to the left
 * by the amount of the width of the first tier.
*/
nav ul ul ul li {
  position: relative;
  top: -80px;
  left: $dropdown-width;
}

// /* Change ' +' in order to change the Dropdown symbol */
// li > a:after {
//   content: " +";
// }
// li > a:only-child:after {
//   content: "";
// }

/* Media Queries
--------------------------------------------- */

@media all and (max-width: 768px) {
  ul ul li {
    background: rgba(0, 0, 0, 0.05);
  }

  nav {
    margin: 0;
  }

  [toggle] + a,
  nav > ul {
    display: none;
  }

  [toggle] {
    display: block;
    padding: 14px 20px;
    color: #fff;
    font-size: 17px;
    text-decoration: none;
    border: none;
  }

  [toggle]:hover {
    [theme="light"] & {
      background-color: darken($theme-background-light, 5);
    }
    [theme="dark"] & {
      background-color: lighten($theme-background-dark, 5);
    }
  }

  /* Display Dropdown when clicked on Parent Lable */
  input[type="checkbox"]:checked + ul {
    display: block;
  }

  /* Change menu item's width to 100% */
  nav ul li {
    display: block;
    width: 100%;
  }

  nav ul ul [toggle],
  nav ul ul a {
    padding: 0 40px;
  }

  nav ul ul ul a {
    padding: 0 80px;
  }

  nav a:hover,
  nav ul ul ul a {
    [theme="light"] & {
      background-color: darken($theme-background-light, 5);
    }
    [theme="dark"] & {
      background-color: lighten($theme-background-dark, 5);
    }
  }

  nav ul li ul li [toggle],
  nav ul ul a,
  nav ul ul ul a {
    padding: 14px 20px;
    color: #fff;
    font-size: 17px;
  }

  nav ul li ul li [toggle],
  nav ul ul a {
    // background-color: #212121;
  }

  /* Hide Dropdowns by Default */
  nav ul ul {
    // float: none;
    position: static;
    color: #ffffff;
    /* has to be the same number as the "line-height" of "nav a" */
  }

  /* Hide menus on hover */
  nav ul ul li:hover > ul,
  nav ul li:hover > ul {
    display: none;
  }

  /* Fisrt Tier Dropdown */
  nav ul ul li {
    display: block;
    width: 100%;
  }

  nav ul ul ul li {
    position: static;
    /* has to be the same number as the "width" of "nav ul ul li" */
  }
}

@media all and (max-width: 330px) {
  nav ul li {
    display: block;
    width: 94%;
  }
}
</style>
